<!DOCTYPE html>
<html lang="de">
<head> 
<!-- 
*************************************************************************************************
*                                                                                               * 
* Zufallsgruppenbilder, Peter Lingemann, 2010/13                                                *
* www.dokspeicher.de/120333 + www.uranmaschine.de                                               *
* Lizenz: Creative Commons CC BY-NC-SA 3.0 DE                                                   *
* Namensnennung - Nicht-kommerziell - Weitergabe unter gleichen Bedingungen 3.0 Deutschland     *
* http://creativecommons.org/licenses/by-nc-sa/3.0/de/                                          *
*                                                                                               * 
*************************************************************************************************
-->

 
   <meta name="author" content="Lgm"/>
    <title>Zufallsgruppenbildner</title>
	
<style type="text/css">
html, body {
  height:100%;
  padding:0px;
  margin:0px;  
}

#page {
  padding-left:30px;
  padding-top:30px;
  min-height:100%;
}
#footer{
 
 
width:100%;
background-color:#eee;
color:#999999;
padding:2px;
padding-left:1em;
font-weight:normal;
font-size:small;
}

#footer a{
color:inherit;
text-decoration:none;
font-size:inherit;
font-weight:inherit;
}

p,a,li,td,span, div, h1,h2,h3,h4,h5,h6 ,input{
        font-family:Verdana, Arial, Helvetica, sans-serif;
		color:#000000;
		line-height:120%;
		font-size:large;
}

p.adminlink, p.adminlink a{
		float:right;
		font-size:small;
		text-decoration:none;

}

h1 {font-size:x-large;}
 div.rahmen{
    padding:5px;
	border:1px solid #ddd;
 }

div.gruppendiv{
    float:left; 
	width:170px;
	border:1px double #ddd;
	margin:5px;
	padding:10px 0px 10px 0px; 
	text-align: center;
	font-size:large;
    background-color:#E0EAF3;
	color:#3366FF;
	font-weight:bold;
	line-height:250%;
}

div.gruppendiv div {
float:left;
color:#7ea2c3;
font-family:Arial Black, "Arial Black", Arial, sans-serif;
font-weight:bold;
font-size:xx-large;
margin-top:-.4em;
margin-bottom:-1em;
padding:0em;
 
}

div.divkrankwahl{
	max-width:15em;
	float:left;
	margin:2px;
}


input.mycb {
        float:left;
		border:0px;
		margin-right:4px;
		margin-left:1px;
		margin-top:1px;
		background-color:#E0EAF3;
}
input.mycb:checked + label{color:#CCCCCC;}

label.klabel {
 	width:10em;
	border: 1px solid #ddd;
	display:block;
    background-color:#E0EAF3;
	color:#3366FF;
	font-weight:bold;
	line-height:250%;
}

select,span.formular {
	background-color:#E0EAF3;
	color:#3366FF;
	font-weight:bold;
	font-size:large;
	padding:5px;
	border:3px double #ddd;
}



select.selectkurswahl{
	width:500px;
	
}

select.selectggroesse{
	width:60px;
	clear:both;

}


input, a.buttonlink {

   background-color:#FFFFFF;
   border:3px double #ddd;
}

div.strukturdiv {
	float:left;
	padding:5px;
	min-width:10em;
	border:1px solid #ddd;
	margin:2px;
}


</style>

</head>
<?php 
 //bergabe pr&uuml;fen, nur Zeichen gem Suchmuster erlaubt
function syntaxok($text){
 
  $kursid=strip_tags($text);
  $kursid=htmlentities($text);
  // Leerzeichen auch nicht erlauben!!
  $suchmuster='/^[0-9a-zA-z_-]{1,}$/';
  if (preg_match($suchmuster,$text)) return TRUE; else return FALSE;
}
// schneidet an Dateinamen letzten Punkt-Anteil ab
function filename_ohne_endung($file){
     $a=array();
	 $a=explode(".",$file);
	 array_pop($a);
	 $file=implode(".",$a);
	 return $file;
} 

function kursdateienauflisten($kursendung){
    GLOBAL $br, $dataverz, $dieseDatei;
    $a_file=array();
	$n=array();
    $verz=opendir($dataverz);
	
	 
	
    while ($file = readdir ($verz)) {

      // Nur kurs-Dateien auflisten
	  $path_parts = pathinfo($file);
	
      if($path_parts["extension"]==$kursendung){ 
          array_push($a_file,$file);
      }
    }   
    sort($a_file);
	
	//Als Auswahlliste ausgeben
	
	echo "<h1>Zufallsgruppenbildner</h1>";
	echo "<p>Bitte Kurs ausw&auml;hlen</p>";
	echo "<form action=\"".$dieseDatei."\" method=\"post\">";
    echo "<select class=\"selectkurswahl\" name=\"kursid\" size=\"10\">";
	foreach($a_file as $value){
    echo "<option value=\"".filename_ohne_endung($value)."\">KURS.".filename_ohne_endung($value)."</option>";
	}
    echo "</select>";
	echo "<p><input type=\"submit\" value=\" Daten laden \"></p>";
	echo "</form>";
	
 
} // ENDE kursdateienauflisten

//Wichtige Festlegugnen

$br="<br/>";
$err=FALSE;
$kursendung="txt";
$action="";
$errtext="";
$dataverz="./testdata/";
$dieseDatei=basename(__FILE__);

// bergabe holen
 
$kursid=$_POST['kursid'];
$action=$_GET['a'];

echo "<body><div id=\"page\">";

if ($action!="") {
 if (!syntaxok($action)) {$err=TRUE;$errtext.=" Befehlssyntax ungueltig";}
} 

if ($kursid!="") {
if (!syntaxok($kursid)) {$err=TRUE;$errtext.=" Kurs unbekannt";}
}

if ($err) {
  	echo "Es ist ein Fehler aufgetreten.".$br;
	echo "Fehlermeldung: ".$errtext;
	echo $br.$br.$br;
	echo "Starten Sie <a href=\"".$dieseDatei."?a=start\">hier</a> neu.";
} else {
   $namensarray= array() ;
// Wenn noch kein Kurs ausgewhlt wurde, Kurs auflisten 
   if($kursid=="") kursdateienauflisten($kursendung);
  // Andernfalls ..
   elseif(isset($_POST['namen'])){
        
      $namen=$_POST['namen'];
	  $fehlt=$_POST['fehlt'];	
	  $ggroesse=$_POST['ggroesse'];	
	  $anzahlsauswahl=$_POST['anzahlsauswahl'];
	  $lehrerdazu=$_POST['lehrerdazu'];
	  $aktion=$_POST['aktion'];
         
	//Verarbeitung der Fehlenden und Sch&uuml;ler mischen, ggf. Lehrer dazu 
	    // nur vorhandene Sch&uuml;ler in neues Array &uuml;bertragen
	    $schueleranzahl=sizeof($namen);
	   	$j=-1;
	   	for ($i=0;$i<$schueleranzahl;$i++){
			 if ($fehlt[$i]!="ja"){$j++; $namensarray[$j]=$namen[$i];}
        }
	    // Lehrer dazu?
		if ($lehrerdazu=="ja") array_push($namensarray,"Lehrer");
	    //neue Schueleranzahl;
		$schueleranzahl=sizeof($namensarray);
		$j=0;
	    // Namen zufllig mischen
	   	shuffle($namensarray);

      // Nun nach Aktion GruppenBilden oder SchuelerWaehlen unterscheiden
	  if ($aktion=="GruppenBilden"){ 
		 // Ermittlung der Anzahl ganzer Gruppen
		 $rest= $schueleranzahl % $ggroesse;
		 $anzganzegruppen = ($schueleranzahl - $rest)/$ggroesse;
		 for ($i=0;$i<$anzganzegruppen;$i++){
		   $gbelegung[$i]=$ggroesse;
		 }
         if($rest==0) { $gbelegung[$anzganzegruppen]=0;		 }
		 elseif($rest==1) {$gbelegung[$anzganzegruppen-1]+=1;
    	               $gbelegung[$anzganzegruppen]=0; }
		 elseif($rest<=($ggroesse-2)) {
		           $zuverteilen=$ggroesse+$rest;
				   $gbelegung[$anzganzegruppen-1]=ceil($zuverteilen/2);
				   $gbelegung[$anzganzegruppen]=$zuverteilen-$gbelegung[$anzganzegruppen-1];
				   $gbelegung[$anzganzegruppen+1]=0;}
		 else {$gbelegung[$anzganzegruppen]=$rest;
                $gbelegung[$anzganzegruppen+1]=0;}
		 
		 $i=0; $z=0;
		 echo "<p>Gruppeneinteilung (mit Lehrervorbehalt)</p>";
		 while($gbelegung[$i]>0 && $z<100){
		   echo "<div class=\"gruppendiv\"><div>".($i+1)."</div>";
		   for ($j=0;$j<$gbelegung[$i];$j++){
         		    echo $namensarray[$z].$br;
					$z++;
		   }
		   $i++;
		   echo "</div>";
		 }

	  } // ENDE IF aktion = GruppenBilden
	  
	  if ($aktion=="PersonenWaehlen") {
	       $anzahl = min($anzahlsauswahl,sizeof($namensarray));
	       $gewaehltarray=array_slice($namensarray, 0, $anzahl);
		   echo "<div class=\"gruppendiv\">";
		   for ($j=0;$j<$anzahl;$j++){
           		    echo $gewaehltarray[$j].$br;
		   }
     	   echo "</div>";
	  } // ENDE IF aktion = PersonenWaehlen
	  echo "<p style=\"clear:both;\">&nbsp;</p>";  
  	   if ($aktion=="PersonenWaehlen") {
	       echo "<p><a class=\"buttonlink\" href=\"javascript:history.back();\">zurck</a></p>";
		   }
	  echo "<p><a class=\"buttonlink\" href=\"".$dieseDatei."\">zum Anfang</a></p>";
	  	 
   } else{
       $err=FALSE; $errtext="";
       $filename=$dataverz.$kursid.".".$kursendung; 
      if (file_exists($filename)){
 	      $fp=fopen($filename,"r");
          if ($fp){
		     
		     while(!feof($fp)) {
             $text = fgets($fp);
			 if($text!="") array_push($namensarray,$text);
            }
          fclose($fp);
		  $anzahleintraege=sizeof($namensarray);
		  
          } //ENDE IF FP
		  else { $err=TRUE; $errtext="Datei konnte nicht geffnet / geladen werden.";}
		   //ENDE IF FP ELSE
		
		  
	  } //ENDE IF FILE EXISTS
	  else {
	    $err=TRUE; $errtext="Datei nicht gefunden.";
	  } //ENDE IF FILE EXISTS ELSE
	  
   if ($err) {
  	     echo "<p>Es ist ein Fehler aufgetreten.".$br;
	     echo "Fehlermeldung: ".$errtext;
	     echo $br.$br.$br;
	     echo "Starten Sie <a href=\"".$dieseDatei."?a=start\">hier</a> neu.</p>";
   } else {
	  
	  // Tabellenaufbau
	  echo "<p>Anzahl der gefundenen Personen: <span>".$anzahleintraege."</span></p> ";
	  echo "<p>Fehlende anklicken</p> ";
	  echo "<form name=\"FormFehlende\" action=\"".$dieseDatei."\" method=\"post\"> ";
 
	  echo "<input type=\"hidden\" name=\"kursid\"  value=\"".$kursid."\"/> ";
     	 for($i=1;$i<=$anzahleintraege;$i++){
	  echo "  <div class=\"divkrankwahl\">";
	  echo "<input class=\"mycb\" type=\"checkbox\" id=\"cbid".$i."\" name=\"fehlt[".($i-1)."]\" value=\"ja\"> ";
	  $name=substr($namensarray[($i-1)],0,12);
	  if ($name<>$namensarray[($i-1)]) $name.=".";
	  echo "  <label class=\"klabel\" for=\"cbid".$i."\" >".$name."</label><input type=\"hidden\" name=\"namen[]\" value=\"".$namensarray[($i-1)]."\">";
	  echo "</div>";
     	 }
		  /*Gste ermglichen*/
		 for($i=1;$i<=3;$i++){
		  echo "  <div class=\"divkrankwahl\">";
		  echo "<input class=\"mycb\" type=\"checkbox\" checked id=\"cbid".($anzahleintraege+$i)."\" name=\"fehlt[".($anzahleintraege+$i-1)."]\" value=\"ja\"> ";
		  $name="Gast ".$i;
		  echo "  <label class=\"klabel\" for=\"cbid".($anzahleintraege+$i)."\" >".$name."</label><input type=\"hidden\" name=\"namen[]\" value=\"".$name."\">";
		  echo "</div>";
     	 }
	  echo "<p style=\"clear:both;font-size:x-small;\">(neuer Browser: es reicht, auf die blauen Flchen zu klicken)</p>";
      echo "<div class=\"strukturdiv\" style=\"clear:both;\">";
	  echo "<p>Gruppengr&ouml;&szlig;e:</p>";
      echo "<select class=\"select_ggroesse\" name=\"ggroesse\" size=\"1\">";
	  echo "<option value=\"2\">2</option>";
	  echo "<option value=\"3\" selected>3</option>";
	  echo "<option value=\"4\">4</option>";
	  echo "<option value=\"5\">5</option>";
	  echo "<option value=\"6\">6</option>";
      echo "</select>";
      echo "<p><input type=\"checkbox\" name=\"lehrerdazu\" value=\"ja\"> Lehrer dazu</p>";	 
  	 
     echo "<p><input type=\"submit\" name=\"aktion\" value=\"GruppenBilden\" caption=\"test\"/></p>";
	 echo "</div>";
     echo "<div class=\"strukturdiv\">";
     echo "<p>Personen ausw&auml;hlen</p>";
     echo "<p>Anzahl</p>";
     echo "<select class=\"select_ggroesse\" name=\"anzahlsauswahl\" size=\"1\">";
      echo "<option value=\"1\" selected>1</option>";
	  for ($i=2;$i<=15;$i++) {
	    echo "<option value=\"".$i."\">".$i."</option>";
	  } 
     echo "</select>";
     echo "<p><input type=\"submit\" name=\"aktion\" value=\"PersonenWaehlen\"/></p>";
	 echo "</div>";
	 echo "</form>";
    }// ENDE IF NOT ERR
   } //ENDE ELSE KURSID=""
   
} // ENDE IF ELSE ERR
?>
</div> <!-- ID = page -->
<div id="footer"> www.dokspeicher.de/120333 - CreativeCommons <a href="http://creativecommons.org/licenses/by-nc-sa/3.0/de/" target="_blank">CC BY-NC-SA 3.0 DE</a></div>
</body>
</html>
